// NB: ERASE STUFF
// Jim Ferrara "antland"
// 4-15-2001 (4-16-2001 today) (4-17-2001 today)
// 6-30-2001 7-13-2001
// 1-12-2002

#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<allegro.h>
#include<time.h>
#include<math.h>
#include<list>


#define S_X          320
#define S_Y          240
#define S_XLIM       240

/*
#define S_X          640
#define S_Y          480
#define S_XLIM       491
*/

#define SIGHT        5
#define QDISTBASE    25
#define FOOD         1001
#define ANT          1002
#define WALL         1003
#define MXFD         15
#define DATVW        0
#define FOV          4
#define NONE         0
#define CIRCRAD      5

#define QUEEN        5000
#define GATHERER     5001

#define DIRTOBASE    2001
#define FINDFOOD     2002
#define DROPOFFFOOD  2003

#define MAXRQUEENS   5
#define MAXYQUEENS   5
#define PHERTIME     20

struct coord {
   int x, y;
};

class node {
   public:
      int x, y;
      int health, maxfood;
      int active;
      int food;
      int speed;
      int id;
      int dir;
      int memtmr, memtmrmax;
      int gest, getc;
      int distbase;
      int type, cargo;
      int behavior;
      void show();  
//   node *next;
};

class wall {
public:
      int x, y;
      int active;
      int health;
      wall();
      void checkup();
};

class redant {
   public:
      node *ptr;
      redant();
};

class yelant {
   public:
      node *ptr;
      yelant();
};

struct rfood {
   int active;
   int present;
   int x, y;
   int amount;
   int regen, rt;
   rfood();
   void checkup();
};

list<node> antlist1;
list<node> antlist2;
//node *antlist1, *antlist2;
BITMAP *buffer, *map, *tbuffer;
BITMAP *pheremones;
PALETTE pal;
FILE *debug, *population;
int currant;
int idant, showpher;
int al1c, al2c, green;
int mx, my, showmat;
int rant, yant, showred, showyel;
int pgt, cgt, killable;
int datview, gotobase, rndmv;
int rqueencount, yqueencount;
wall wallmap[S_XLIM][S_Y];
rfood rfoodmap[S_XLIM][S_Y];
redant redmap[S_XLIM][S_Y];
yelant yelmap[S_XLIM][S_Y];
coord redbase, yelbase;

int distance(int x1, int x2, int y1, int y2);
int init_mem(int dir, int x, int y, int tm);
void readlevel();
void printlist(node *list);
void movebugs(int tm);
void showbugs(int x);
void killfmap();
void update_rfood();
void drawcircleofood();
void cpheremones(int minus);

int main() {
   int timetopher = 0;
   datview = DATVW;
   yant = rant = cgt=gotobase=rndmv=0;
   killable = showmat = showpher = 0;
   showred = showyel = 1;
   srand(time(0));
   mx = S_XLIM/2;
   my = S_Y/2;
   currant = idant = pgt = 0;
   int tlp = 5000;
	rqueencount = yqueencount = 0;

   srand(time(0));
   debug = fopen("debug3.txt", "w");
   population = fopen("population.txt", "w");
   allegro_init();
//   install_mouse();
//   install_timer();
   install_keyboard();
   set_color_depth(24);
   set_gfx_mode(GFX_AUTODETECT, S_X, S_Y, 0, 0);
   text_mode(-1);

   if((S_X==640) && (S_Y==480))
      map = load_bmp("bmap.bmp", NULL);
   else
      map = load_bmp("smap.bmp", NULL);
   buffer = create_bitmap(S_X, S_Y);
   pheremones = create_bitmap(S_XLIM, S_Y);
   clear(pheremones);
   tbuffer = create_bitmap(200, 40);
   blit(map, buffer, 0, 0, 0, 0, S_X, S_Y);
   blit(buffer, screen, 0, 0, 0, 0, S_X, S_Y);

   al1c = makecol(255, 0, 0);
   al2c = makecol(255, 255, 0);
   readlevel();
   blit(buffer, screen, 0, 0, 0, 0, S_X, S_Y);
   fprintf(debug, "Starting loop\n");
   for(int i = 0; i < tlp; i++)
   {
      if(timetopher == PHERTIME) {
         timetopher = 0;
         cpheremones(1);
      }
      else
         timetopher++;

      movebugs(1);
      movebugs(2);
      draw_sprite(buffer, map, 0, 0);
      if(showred)
         showbugs(1);
      if(showyel)
         showbugs(2);
      update_rfood();

      if(showmat) {
         for(int j= 0; j<S_XLIM; j++) {
            for(int k=0; k<S_Y; k++) {
               if(yelmap[j][k].ptr!=NULL)
                  if((yelmap[j][k].ptr->active) && (yelmap[j][k].ptr->health>0))
                     putpixel(buffer, j, k, makecol(255, 255, 255));
               if(redmap[j][k].ptr!=NULL)
                  if((redmap[j][k].ptr->active) && (redmap[j][k].ptr->health>0))
                     putpixel(buffer, j, k, makecol(128, 128, 128));
            }
         }
      } 

      if((S_X==320) && (S_Y==240)) {
         textprintf(buffer, font, 243, 10, makecol(255, 255, 255), "Frame:");
         textprintf(buffer, font, 243, 20, makecol(255, 255, 255), "(%d /", i);
         textprintf(buffer, font, 243, 30, makecol(255, 255, 255), " %d )", tlp);
         textprintf(buffer, font, 243, 50, makecol(255, 255, 255), "Ant Count");
         textprintf(buffer, font, 243, 60, makecol(255, 255, 255), "%d", currant);
         textprintf(buffer, font, 243, 70, makecol(255, 255, 255), "Yellow:");
         textprintf(buffer, font, 243, 80, makecol(255, 255, 255), "%d", yant);
         textprintf(buffer, font, 243, 90, makecol(255, 255, 255), "Red:");
         textprintf(buffer, font, 243, 100, makecol(255, 255, 255), "%d", rant);
         textprintf(buffer, font, 243, 110, makecol(255, 255, 255), "GTB: %d", gotobase);
         textprintf(buffer, font, 243, 120, makecol(255, 255, 255), "RND: %d", rndmv);
         textprintf(buffer, font, 243, 130, makecol(255, 255, 255), "KLA: %d", killable);
         textprintf(buffer, font, 243, 140, makecol(255, 255, 255), "S-RED: %d", showred);
         textprintf(buffer, font, 243, 150, makecol(255, 255, 255), "S-YEL: %d", showyel);
         textprintf(buffer, font, 243, 160, makecol(255, 255, 255), "S-MAT: %d", showmat);
      }

      if((S_X==640) && (S_Y==480)) {
         textprintf(buffer, font, 493, 10, makecol(255, 255, 255), "Frame:");
         textprintf(buffer, font, 493, 20, makecol(255, 255, 255), "(%d /", i);
         textprintf(buffer, font, 493, 30, makecol(255, 255, 255), " %d )", tlp);
         textprintf(buffer, font, 493, 50, makecol(255, 255, 255), "Ant Count");
         textprintf(buffer, font, 493, 60, makecol(255, 255, 255), "%d", currant);
         textprintf(buffer, font, 493, 70, makecol(255, 255, 255), "Yellow:");
         textprintf(buffer, font, 493, 80, makecol(255, 255, 255), "%d", yant);
         textprintf(buffer, font, 493, 90, makecol(255, 255, 255), "Red:");
         textprintf(buffer, font, 493, 100, makecol(255, 255, 255), "%d", rant);
      }
//      if(rand()%300)
//         drawcircleofood();

      fprintf(population, "%d, %d, %d, %d, \n", i, currant, yant, rant);

      putpixel(buffer, mx, my, makecol(128, 128, 128));

      if(showpher) 
         blit(pheremones, buffer, 0, 0, 0, 0, S_XLIM, S_Y);

      blit(buffer, screen, 0, 0, 0, 0, S_X, S_Y);
      if((key[KEY_Q]) || (key[KEY_ESC]))
         break;
      if(key[KEY_M]) {
         key[KEY_M] = false;
         tlp+=500;
      }
      if(key[KEY_P]) {
         readkey();
         key[KEY_P] = 0;
      }
      if(key[KEY_K]) {
         killfmap();
      }
      if(key[KEY_N]) {
         if(showpher)
            showpher=0;
         else
            showpher=1;
         key[KEY_N]=false;
      }
      if(key[KEY_Y]) {
         if(showyel)
            showyel=0;
         else
            showyel=1;
         key[KEY_Y]=false;
      }
      if(key[KEY_U]) {
         if(showred)
            showred=0;
         else
            showred=1;
         key[KEY_U]=false;
      }
      if(key[KEY_S]) {
         if(showmat) 
            showmat=0;
         else
            showmat=1;
         key[KEY_S]=false;
      }
      if(key[KEY_G]) {
         if(gotobase)
            gotobase=0;
         else
            gotobase=1;
         key[KEY_G]=false;
      }
      if(key[KEY_R]) {
         if(rndmv)
            rndmv=0;
         else
            rndmv=1;
         key[KEY_R]=false;
      }
      if(key[KEY_W]) {
         if(killable)
            killable=0;
         else
            killable=1;
         key[KEY_W]=false;
      }
      if(key[KEY_UP])
         my--;
      if(key[KEY_DOWN])
         my++;
      if(key[KEY_LEFT])
         mx--;
      if(key[KEY_RIGHT])
         mx++;
   }
   readkey();
   fclose(debug);
   fclose(population);
   destroy_bitmap(tbuffer);
   destroy_bitmap(map);
   destroy_bitmap(buffer);
   destroy_bitmap(pheremones);
   allegro_exit();
   printf("Done");
   return(0);
}
END_OF_MAIN();

void readlevel() {
   clear_to_color(screen, makecol(255, 255, 255));

   node temp;
   for(int x = 0; x < S_XLIM; x++) {
      for(int y = 0; y < S_Y; y++)  {
         if(getpixel(map, x, y) == makecol(255, 0, 0)) {
            temp.x = x;
            temp.y = y;
            temp.active = 1;
            temp.health = rand()%150;
            temp.food = 50;
            temp.speed = 1;
            temp.id = currant;
            temp.dir = rand()%256;
            temp.memtmr=0;
            temp.gest=rand()%200+200;
            temp.getc=0;
            temp.memtmrmax=rand()%200+200;
            temp.distbase=(int)pow((rand()%(S_X/2))+20, 2)+25;
            temp.maxfood=temp.health*MXFD;
				if(rqueencount < MAXRQUEENS) { temp.type=rand()%2+5000; }
				else { temp.type=GATHERER; }
            if(temp.type==QUEEN) {
               temp.distbase=QDISTBASE;
               temp.gest=rand()%50+20;
               temp.behavior=DIRTOBASE;
					rqueencount++;
            }
            putpixel(map, x, y, makecol(0, 0, 0));
            antlist1.push_back(temp);
            rant++;
            currant++;
         }
         else if(getpixel(map, x, y) == makecol(255, 255, 0)) {
            temp.x = x;
            temp.y = y;
            temp.active = 1;
            temp.health = rand()%150;
            temp.food = 50;
            temp.speed = 1;
            temp.id = currant;
            temp.dir = rand()%256;
            temp.memtmr = 0;
            temp.gest=rand()%200+200;
            temp.getc=0;
            temp.memtmrmax=rand()%200+200;
            temp.distbase=(int)pow((rand()%(S_X/2))+20, 2)+25;
            temp.maxfood=temp.health*MXFD;
				if(rqueencount < MAXYQUEENS) { temp.type=rand()%2+5000; }
				else { temp.type=GATHERER; }
            if(temp.type==QUEEN) {
               temp.distbase=QDISTBASE;
               temp.gest=rand()%50+20;
               temp.behavior=DIRTOBASE;
					yqueencount++;
            }
            putpixel(map, x, y, makecol(0, 0, 0));
            antlist2.push_back(temp);
//            add2list(temp, 2);
            yant++;
            currant++;
         }
         else if(getpixel(map, x, y) == makecol(0, 0, 255)) {
            wallmap[x][y].active = 1;
            wallmap[x][y].x = x;
            wallmap[x][y].y = y;
         }
         else if(getpixel(map, x, y) == makecol(255, 128, 64)) {
            rfoodmap[x][y].active = 1;
            rfoodmap[x][y].x = x;
            rfoodmap[x][y].y = y;
            rfoodmap[x][y].present = 1;
         }
         else if(getpixel(map, x, y) == makecol(1, 1, 1)) {
            redbase.x = x;
            redbase.y = y;
         }
         else if(getpixel(map, x, y) == makecol(2, 2, 2)) {
            yelbase.x = x;
            yelbase.y = y;
         }
         else if(getpixel(map, x, y) == makecol(0, 255, 0)) {
            putpixel(map, x, y, makecol(0, 255, 0));
         }

         if(datview) {
            clear_to_color(tbuffer, makecol(255, 255, 255));
            textprintf(tbuffer, font, 10, 10, makecol(0, 0, 0), "X: %d Y: %d", x, y);
            textprintf(tbuffer, font, 10, 20, makecol(0, 0, 0), "ANT COUNT: %d", currant);
            blit(tbuffer, screen, 0, 0, 0, 0, 200, 40);
         }
      }
   }
   textprintf(screen, font, 10, 30, makecol(0, 0, 0), "Ready???");
   readkey();
}

void showbugs(int x) {
   list<node>::iterator i;
   if(x == 1) {
      i = antlist1.begin();
      while(i!=antlist1.end()) {
         if((*i).active)
            putpixel(buffer, (*i).x, (*i).y, makecol(255, 0, 0));
         else if(((*i).health != -100) && ((*i).type == QUEEN))
            putpixel(buffer, (*i).x, (*i).y, makecol(255, 255, 255));
         i++;
      }
   }

   if(x == 2) {
      i = antlist2.begin();
      while(i!=antlist2.end()) {
         if((*i).active)
            putpixel(buffer, (*i).x, (*i).y, makecol(255, 255, 0));
         else if(((*i).health != -100) && ((*i).type == QUEEN))
            putpixel(buffer, (*i).x, (*i).y, makecol(255, 255, 255));
         i++;
      }
   }
}

void killfmap() {
   for(int x = 0; x < S_XLIM; x++) {
      for(int y = 0; y < S_Y; y++) {
         if(getpixel(map, x, y) == makecol(0, 255, 0)) {
            putpixel(map, x, y, makecol(0, 0, 0));
         }
      }
   }
}

int init_mem(int dir, int x, int y, int tm) {
   int r, g, b;
   fixed x_mv, y_mv, retdir;
   int xl, yl;
   int rx, ry;
   int alook;
   rx = ry = 0;
   if(tm==1) {
      r = 255;
      g = 255;
      b = 0;
   }
   else {
      r = 255;
      g = 0;
      b = 0;
   }
   int gp;

   for(alook = dir-FOV; alook <= dir+FOV; alook+=2) {
      for(int i = 0; i < SIGHT; i++) {
         x_mv = fcos(itofix(alook))*i;
         y_mv = fsin(itofix(alook))*i;

         xl = fixtoi(x_mv);
         yl = fixtoi(y_mv);

         gp = getpixel(screen, x+xl, y+yl);

         if(gp == makecol(0, 255, 0)) {
            retdir = fatan2(yl, xl);
            dir = fixtoi(retdir);
         }

         if(gp == makecol(r, g, b)) {
            retdir = fatan2(yl, xl);
            dir = fixtoi(retdir);
         }
//         putpixel(screen, x+xl, y+yl, makecol(255, 255, 255));
      }
      putpixel(screen, x+xl, y+yl, makecol(255, 255, 255));
   }
/*   if(dir!=192)
      return(dir);
   else
      return(rand()%256); */
   return(dir);
}

void update_rfood() {
   for(int x = 0; x < S_XLIM; x++) 
      for(int y = 0; y < S_Y; y++) {
         rfoodmap[x][y].checkup();
         wallmap[x][y].checkup();
      }
}


wall::wall() {
   active = 0;
   health = 25;
}

void wall::checkup() {
   if(health <= 0) {
      active = 0;
      putpixel(map, x, y, makecol(0, 0, 0));
   }
}

rfood::rfood() {
   active = 0;
   present = 0;
   x = y = -1;
   amount = 25;
   regen = rand()%200+200;
   rt = 0;
}

void rfood::checkup() {
   if(present) {  
      if(!active) {
         if(rt == regen) {
            present = 1;
            active = 1;
            rt = 0;
            putpixel(map, x, y, makecol(255, 128, 64));
         }
         else rt++;
      }
   }
}

redant::redant() {
   ptr = NULL;   
}

yelant::yelant() {
   ptr = NULL;
}

int distance(int x1, int x2, int y1, int y2) {
   int x, y;
   x = x2-x1;
   y = y2-y1;
   x = (int)pow(x, 2);
   y = (int)pow(y, 2);
   return(x+y);
}

void drawcircleofood() {
   int x, y;
   x = rand()%S_XLIM;
   y = rand()%S_Y;
   for(int i = 0; i < 256; i++)
      for(int j=0; j < CIRCRAD; j++) {
         putpixel(map, x+fixtoi(fcos(itofix(i)))*j, y+fixtoi(fsin(itofix(i)))*j, makecol(0, 255, 0));
      }
}

void movebugs(int tm)
{
   node temp2;
   int rx, ry, xl, yl;
   list<node>::iterator i;
   if(tm == 1) i = antlist1.begin();
   else  i = antlist2.begin();
   while(1) {
      if((i == antlist1.end()) || (i == antlist2.end())) break; 
      if(((*i).active == 1) && ((*i).health > 0)) {
         if(tm == 1)
            redmap[(*i).x][(*i).y].ptr = NULL;
         else
            yelmap[(*i).x][(*i).y].ptr = NULL; // delete current settings in matrix

         fixed move_x, move_y;
         move_x = fcos(itofix((*i).dir))*(*i).speed;
         move_y = fsin(itofix((*i).dir))*(*i).speed;
         rx=fixtoi(move_x);
         ry=fixtoi(move_y);
         (*i).dir+=rand()%256;
         if((*i).food > 0)
            (*i).food--;
         else if((*i).health > 0)
            (*i).health--;
         if((*i).health <= 0) {
            if(tm==1)
               rant--;
            else
               yant--; 
            currant--;
            (*i).active = 0;
         }

         if((*i).type==QUEEN) {
            if((*i).getc>=(*i).gest) {
               if(rand()%3) {
//               temp2 = new node;
                  temp2.x = (*i).x;
                  temp2.y = (*i).y;
                  temp2.active = 1;
                  temp2.health = rand()%200;
                  temp2.maxfood = (*i).maxfood+(rand()%5-3);
                  temp2.food = (*i).food;
                  temp2.speed = (*i).speed;
                  temp2.id = currant;
                  temp2.dir = (*i).dir;
                  temp2.type=rand()%3+5000;
                  temp2.memtmr=0;
                  temp2.gest=(*i).gest;
                  temp2.getc=0;
                  temp2.memtmrmax=(*i).memtmr+rand()%2;
                  temp2.distbase=(int)pow((rand()%(S_X/2))+20, 2)+25;
                  if(temp2.type==QUEEN)
                     if(rand()%5<2)
                        temp2.type=GATHERER;
                  if(temp2.type==QUEEN) {
                     temp2.distbase=QDISTBASE;
                     temp2.gest=rand()%50+20;
                     temp2.behavior=DIRTOBASE;
                  }
                  if(temp2.type==GATHERER)
                     temp2.behavior=FINDFOOD;
                  if(tm == 1) antlist1.push_back(temp2);
                  else antlist2.push_back(temp2);
                  if(tm == 1)
                     rant++;
                  else
                     yant++; 
                  currant++;
                  (*i).getc=0;
               }
            }
            else
               (*i).getc++;
         }

         // Deal with walls
         if(getpixel(map, int((*i).x + rx), int((*i).y + ry)) != makecol(0, 0, 255)) {
            (*i).x+=rx;
            (*i).y+=ry;
         }
         // follow the walls
         else {
            if(!wallmap[(*i).x+fixtoi(fcos(itofix((*i).dir+32)))][(*i).y+fixtoi(fsin(itofix((*i).dir+32)))].active)
               (*i).dir+=32;
            else if(!wallmap[(*i).x+fixtoi(fcos(itofix((*i).dir-32)))][(*i).y+fixtoi(fsin(itofix((*i).dir-32)))].active)
               (*i).dir-=32;
            else
               (*i).dir-=(rand()%3-1)*64;
            wallmap[(*i).x+rx][(*i).y+ry].health-=1;
         }
         //get regen food
         if(getpixel(map, (*i).x+rx, (*i).y+ry) == makecol(255, 128, 64)) {
            if(rfoodmap[(*i).x+rx][(*i).y+ry].active) {
               (*i).food+=rfoodmap[(*i).x+rx][(*i).y+ry].amount;
               rfoodmap[(*i).x+rx][(*i).y+ry].active = 0;
               rfoodmap[(*i).x+rx][(*i).y+ry].rt=0;
               putpixel(map, (*i).x+rx, (*i).y+ry, makecol(0, 0, 0));
            }
            for(int px = -1; px <= 1; px++) {
               for(int py = -1; py <= 1; py++) {
                  green = getg24(getpixel(pheremones, (*i).x+px, (*i).y+py));
                  if(green < 255)
                     putpixel(pheremones, (*i).x+px, (*i).y+py, makecol(0, green+5, 0));
               }
            }
         }
         /*
         DROP A FOOD MARKER HERE AND ON THE WAY BACK
         */
         if(getpixel(map, int((*i).x), int((*i).y)) == makecol(0, 255, 0)) {
            if((*i).food < (*i).maxfood) {
               (*i).health+=rand()%60;
               putpixel(map, int((*i).x), int((*i).y), makecol(0, 0, 0));
            }
            else {
               (*i).cargo=FOOD;
               (*i).behavior=DROPOFFFOOD;
               putpixel(map, int((*i).x), int((*i).y), makecol(0, 0, 0));
            }
         }
         // IF YOU ARE GOING TO DROP OFF SOME FOOD
         if((*i).behavior==DROPOFFFOOD) {
            if(tm==1) {
               if(distance((*i).x, redbase.x, (*i).y, redbase.y) > QDISTBASE) {
                  (*i).dir = fixtoi(fatan2(redbase.y-(*i).y, redbase.x-(*i).x));
                  for(int px = -1; px <= 1; px++) {
                     for(int py = -1; py <= 1; py++) {
                        green = getg24(getpixel(pheremones, (*i).x+px, (*i).y+py));
                        if(green < 255)
                           putpixel(pheremones, (*i).x+px, (*i).y+py, makecol(0, green+5, 0));
                     }
                  }
               }
               else {
                  if((*i).cargo==FOOD) {
                     putpixel(map, (*i).x+rx, (*i).y+ry, makecol(0, 255, 0));
                     (*i).behavior=FINDFOOD;
                     (*i).cargo=NONE;
                  }
                  else
                    (*i).behavior=FINDFOOD;
               }
            }
            if(tm==2) {
               if(distance((*i).x, yelbase.x, (*i).y, yelbase.y) > QDISTBASE) {
                  (*i).dir = fixtoi(fatan2(yelbase.y-(*i).y, yelbase.x-(*i).x));
                  for(int px = -1; px <= 1; px++) {
                     for(int py = -1; py <= 1; py++) {
                        green = getg24(getpixel(pheremones, (*i).x+px, (*i).y+py));
                        if(green < 255)
                           putpixel(pheremones, (*i).x+px, (*i).y+py, makecol(0, green+5, 0));
                     }
                  }
               }
               else {
                  if((*i).cargo==FOOD) {
                     putpixel(map, (*i).x+rx, (*i).y+ry, makecol(0, 255, 0));
                     (*i).behavior=FINDFOOD;
                     (*i).cargo=NONE;
                  }
                  else
                     (*i).behavior=FINDFOOD;
               }
            }
         }
/*
         if(((*i).type != QUEEN) && ((*i).behavior != DROPOFFFOOD) && ((*i).behavior != DIRTOBASE)) {
            int max = 0;
            int pdx, pdy;
               for(int px = -1; px <= 1; px++) {
                  for(int py = -1; py <= 1; py++) {
                     green = getg24(getpixel(pheremones, (*i).x+px, (*i).y+py));
                     if(max < green) {
                        pdx = px;
                        pdy = py;
                     }
                  }
               }

               if((pdx == -1) && (pdy == -1))
                  (*i).dir = 92;
               else if((pdx == 0) && (pdy == -1))
                  (*i).dir = 64;
               else if((pdx == 1) && (pdy == -1))
                  (*i).dir = 32;

               else if((pdx == -1) && (pdy == 0))
                  (*i).dir = 128;
               else if((pdx == 1) && (pdy == 0))
                  (*i).dir = 0;

               else if((pdx == -1) && (pdy == 1))
                  (*i).dir = 160;
               else if((pdx == 0) && (pdy == 1))
                  (*i).dir = 192;
               else if((pdx == 1) && (pdy == 1))
                  (*i).dir = 224;
          }        
*/
      } // IS THIS BRACKET 6???

      if((*i).active == 0) {
         if((*i).health > -50)
            (*i).health--;
         else if((*i).health == -50) {
            putpixel(map, (*i).x, (*i).y, makecol(0, 255, 0));
            (*i).health = -100;
         if(tm==1) {
            redmap[(*i).x][(*i).y].ptr=NULL;
         // ERASE HERE         
         }
         if(tm==2) {
            yelmap[(*i).x][(*i).y].ptr=NULL;
         // ERASE HERE
         }
      }
   } // MAYBE THIS IS BRACKET 6???

      if(((gotobase) && ((*i).behavior==DIRTOBASE)) || ((*i).type == QUEEN)) {
         if(tm==1) {
            if(distance((*i).x, redbase.x, (*i).y, redbase.y) > (*i).distbase)
               (*i).dir = fixtoi(fatan2(redbase.y-(*i).y, redbase.x-(*i).x));
            else 
               (*i).dir+=rand()%FOV-(FOV/2);
         }
         if(tm==2) {
            if(distance((*i).x, yelbase.x, (*i).y, yelbase.y) > (*i).distbase)
               (*i).dir = fixtoi(fatan2(yelbase.y-(*i).y, yelbase.x-(*i).x));
            else
               (*i).dir+=rand()%FOV;
         }
      }

      if(rndmv)
         (*i).dir+=rand()%256;

      if(tm == 1) {
         redmap[(*i).x][(*i).y].ptr = &(*i);
      }
      else
         yelmap[(*i).x][(*i).y].ptr = &(*i); 
           
      if((*i).x <= 0) {
         (*i).x = 1;
         (*i).dir-=128; }
      if((*i).x >= S_XLIM) {
         (*i).x = S_XLIM-1;
         (*i).dir-=128; }
      if((*i).y <= 0) {
         (*i).y = 1;
         (*i).dir-=128; }
      if((*i).y >= S_Y-1) {
         (*i).y = S_Y-1;
         (*i).dir-=128; }
      i++;
   }
}

void cpheremones(int minus) {
   green = 0;
   for(int x = 0; x < S_XLIM; x++) {
      for(int y = 0; y < S_Y; y++) {
         green = getg24(getpixel(pheremones, x, y));
         if(green>minus)
            green-=minus;
         putpixel(pheremones, x, y, makecol(0, green, 0));
      }
   }
}
